

%{

#define STACK_SIZE 42
  
int da_stack[STACK_SIZE];
  
int sp;

enum { TOKEN_NUM, TOKEN_OP};
  
typedef union
{
  int num;
  char op;
} val_t;
  
  
val_t da_val;
  
%}





%%

[ \t\n]+ ;
[0-9]+  { sscanf(yytext, "%d", &(da_val.num)); return TOKEN_NUM;}
[-+*/pq] { da_val.op = *yytext; return TOKEN_OP;}

%%

int main(void)
{
  int token;

  sp = 0;

  while (1)
    {
      token = yylex();
      

      if (token == TOKEN_NUM)
	{
	  /* printf("On a reconnu un token num, de valeur %d.\n", da_val.num);
	   */
	  if (sp >= STACK_SIZE)
	    {
	      printf("Stack overflow.\n");
	      exit(42);
	    }
	  da_stack[sp] = da_val.num;
	  sp++;
	  continue;
	}


      
      switch (da_val.op)
	{
	case 'p':
	  if (sp < 1 )
	    printf("Stack empty.\n");
	  else
	    printf("%d\n", da_stack[sp - 1]);
	  break;
	  
	case 'q':
	  exit(0);
	  
	case '+':
	  if (sp < 2)
	    {
	      printf("Erreur.\n");
	      exit(42);
	    }
	  da_stack[sp - 2] = da_stack[sp - 1] + da_stack[sp - 2];
	  sp--;
	  break;

	case '*':
	  if (sp < 2)
	    {
	      printf("Erreur.\n");
	      exit(42);
	    }
	  da_stack[sp - 2] = da_stack[sp - 1] * da_stack[sp - 2];
	  sp--;
	  break;

	case '/':
	  if (sp < 2)
	    {
	      printf("Erreur.\n");
	      exit(42);
	    }
	  if (da_stack[sp - 1] != 0)
	    {
	      da_stack[sp - 2] = da_stack[sp - 2] / da_stack[sp - 1];
	      sp--;
	    }
	  break;

     	case '-':
	  if (sp < 2)
	    {
	      printf("Erreur.\n");
	      exit(42);
	    }
	  da_stack[sp - 2] = da_stack[sp - 2] - da_stack[sp - 1];
	  sp--;
	  break;

	}
    }
  return 0;
}
