(*version 1 compression des tables par dcalage de lignes *)



#use "recup_donnees.ml";;


(*on suppose que on a moulin avant un rsultat du type (t,m,n) o t est
  le tableau des donnes, m son nombre de lignes et n son nombre de colonnes*)

(*(ligne,colonne)*)



let make_bad_states tab_ini m n =
(* le bitmap des transitions rates, description dtaille dans le bout
   de code C *)
  let da_bitmap = Array.make_matrix m  (n / 8) 0 in
  for i = 0 to m - 1 do
    for j = 0 to (n/8) - 1 do
      let c = ref 0 in
      for k = (8 * j) to (8 * j) + 7 do
	if (tab_ini.(i).(k) < 0) then 
	  c := (!c * 2) + 1
	else
	  c := (!c * 2);
      done;
      da_bitmap.(i).(j) <- !c;
    done;
  done;
  da_bitmap;;
    
let compte_neg t m n  =
(* renvoie t o t(i) contient (nombre de <0 de la ligne i,i)*)
  let res = Array.make m (0,0) and nb = ref 0 in
    for i=0 to m-1 do
      nb:=0;
      for j=0 to n-1 do
	if (t.(i).(j)<0) then nb:=!nb+1;
      done;
      res.(i)<-(!nb,i);
    done;
    res;;

let compare_fct a b =
(* fonction de comparaison utilise dans la fonction Array.sort*)
(*Hack pour rcuprer une fonction 'a->'a->int*)
  if (snd a = snd b) then
    if (fst a)< (fst b) then -1 else (if (fst a)=(fst b) then 0 else 1)
  else
    if (fst a)< (fst b) then -1 else (if (fst a)=(fst b) then 0 else 1);;

(*compare_fct (3,1) (2,7);;*)

let trie_tab_selon_neg table=
    Array.sort compare_fct table;;

exception Placement_mauvais;; (*pour la fonction  suivante*)
exception Placement_bon;;

let essaie_placement ligne (nb_el:int) tableau (indice:int) =
  (*cela rpond vrai ssi la ligne peut tre insre  l'indice, cad tous 
    ses lments soit crasent des <0 soit crasent des trucs
    identiques et place la ligne et renvoie 0 sinon -1*)
  (* !! ici on ne vrifie pas si le tableau est assez grand*)
  try
    for i=0 to nb_el-1 do
      if ((ligne.(i)<>tableau.(indice+i) && (ligne.(i)>=0) &&(tableau.(indice+i))>=0))
      then 
	raise Placement_mauvais;
    done;
    raise Placement_bon
  with
    |Placement_bon -> 
       (
	 for j=0 to nb_el-1 do 
	   if (ligne.(j)>tableau.(j+indice)) then tableau.(j+indice)<-ligne.(j);
	 done;
	 0)
    |Placement_mauvais -> -1
;;

let place_ligne ligne (nb_el:int) tableau = 
(*la aussi, on imagine que le tableau est assez grand!
  donc on place forcment . Noter que le tableau est modifi
  apres la sortie de la fonction*) 
  let indice = ref 0 and toto = ref (-1) in
    while (!toto= (-1)) do
      toto:=essaie_placement ligne nb_el tableau !indice;
      indice:=!indice+1;
    done;
    !indice-1;;

(*essais des fonction auxillaires*)
let t=[|2;0;5;2;-5;5;0;0|];;
let a=[|2;-6;5|];;
essaie_placement a 3 t 0;;
place_ligne a 3 t ;;
t;;

let t2=[|(0,0);(3,1);(2,2)|];;
trie_tab_selon_neg t2;;
t2;;
(*ca marche !*)

let cte = -666;; (*c'est <0 donc on peut scroucher*)

let enleve_cte tab =
(*les cte qu'il faut enlever sont  la fin 
et il y a au-moins un element <>cte*)
  let i = ref (Array.length tab - 1 )  in 
    while (!i>0) && (tab.(!i)=cte) do
      i:=!i-1
    done;
 Array.sub tab 0 (!i+1);;


enleve_cte [|6;9;7;0;0;-666;-666|];;
enleve_cte [|0;9|];;


let compresse_table matrice m n=
(*la fonction principale*)
  let tab_compressee = Array.make (n*m) cte (*la taille du tableau au pire*)
  and tab_decalages = Array.make m 0  in 
(*  let table_bad_states = make_bad_states matrice m n  in*)
  let table_neg = compte_neg matrice m n  in
    trie_tab_selon_neg table_neg;
    for i=0 to m-1 do
      let indice_ligne_a_placer = snd table_neg.(i) in
	tab_decalages.(indice_ligne_a_placer)<-
	place_ligne matrice.(indice_ligne_a_placer) n tab_compressee ;
	(*place_ligne a la bonne idee d'avoir des effets de bords!*)
    done;
    (*table_bad_states,*)
     (enleve_cte tab_compressee,tab_decalages)
;;


let matrice_essai = [| [|1;-6;2|];[|1;0;2|];[|3;0;0|];[|3;0;0|] |];;
(*exemple du Grune*)

let tt = compte_neg matrice_essai 4 3;;
trie_tab_selon_neg tt;;
tt;;
compresse_table matrice_essai 4 3 ;;

(*ok a marche*)


(*----------interfacage avec lex -----------*)

let laissons_passer_jusque_yy_nxt entree sortie = 
(* il faut laisser passer jusque yy_nxt en l'enlevant *)
  let aux  = function
      (0, 'y') -> 1
    | (1, 'y') -> 2
    | (2, '_') -> 3
    | (3, 'n') -> 4
    | (4, 'x') -> 5
    | (5, 't') -> 6
    | (2, 'y') -> 1
    | (_, _) -> 0
  in
  let matched_aux = function
    | 0 -> ""
    | 1 -> "y"
    | 2 -> "yy"
    | 3 -> "yy_"
    | 4 -> "yy_n"
    | 5 -> "yy_nx"
    | _ -> failwith "erreur dans matched_aux"
  in
  let q = ref 0 in
  while (!q <> 6) do
    let last_state = !q in
    let c = input_char entree in
    q := aux (!q, c);
    if (!q = 0) then
      (
       output_string sortie (matched_aux last_state);
       output_char sortie c;
      );
  done;;

let recuperer_truc_entre_crochets entree =
(* pour changer facilement les occurences suivantes de yy_nxt
   il faut remplacer les acces au tableau par un appel de fonction *)
  while ((input_char entree) <> '[') do
    ()
  done;
  let buffer = ref "" in
  let k = ref true in
  while (!k) do
    let c = input_char entree in
    if (c = ']') then
      k := false
    else
      (
       buffer := !buffer ^ "e";
       String.set !buffer ((String.length !buffer) - 1) c;
      )
    done;
  !buffer;;
      
  
let manger_jusque_semi_colomn entree = 
(* pour effacer l'ancien tableau de transitions non compresse *)
  while ((input_char entree) <> ';') do
    ()
  done;;



let ecrit_yy_nxt_with_lines tab m sortie =     
(*ecriture du tableau yy_nxt_with_lines dans le fichier sortie*)                                                                               
  output_string sortie "yy_next_with_lines[] =\n{";  
  for i = 0 to m - 2 do                                                                                                               
      output_string sortie (string_of_int (tab.(i)));                        
      output_string sortie ", ";
      if (m mod 16 = 0) then output_string sortie "\n";
    done;                                                                        
    output_string sortie (string_of_int (tab.(m-1)));                      
    output_string sortie "};\n";;                                                   
     

let ecrit_yy_empty_state tab m sortie =  
(*ecriture du tableau yy_empty_state dans le fichier sortie*)
  output_string sortie "char yy_empty_state[][16] = \n{\n";
  let n=16 in
  for i = 0 to m - 1 do                                                          
    output_string sortie "{\n";                                                  
    for j = 0 to n - 2 do                                                        
      output_string sortie (string_of_int (tab.(i).(j)));                        
      output_string sortie ", ";                                                 
    done;                                                                        
    output_string sortie (string_of_int (tab.(i).(n - 1)));                      
    output_string sortie "}";                                                    
    if (i <> (m - 1)) then output_string sortie ",\n";                           
  done;                                                                          
  output_string sortie "};\n";;                                                
                                                                                 
    
let ecrit_yy_skip tab m sortie =    
  (*ecriture du tableau yy_skip dans le fichier sortie*)                                       
  output_string sortie "short yy_skip[] = \n{\n";                                                                             
    for j = 0 to m - 2 do                                                        
      output_string sortie (string_of_int tab.(j));                          
      output_string sortie ", ";                                                 
    done;                                                                        
    output_string sortie (string_of_int tab.(m - 1));                        
  output_string sortie "};\n";;                                                   
                                                                                 
   
let gros_bout_de_c = 
"

/*
  Le programme Ocaml a cree correctement les tableaux:                           
  - yy_nxt_with_lines                                                           
  - yy_empty_state                                                       
  - yy_skip

yy_next_with_lines est le tableau des lignes de transitions
aplaties par l'algo de compressions des lignes.

yy_empty_state permet de savoir o taient les tats puits:
tableau de char  16 colonnes et                        
  avec autant de lignes que d'tats. La transition                               
  (state, char) est une transition vers echec si le bit                          
  de rang (char % 8) de l'element de colonne (char / 8)                          
  et de ligne state est  1, ce qui correspond effectivement                     
  au char ieme bit du tableau si on les concatenait. 

yy_skip est le tableau des dcalages utilis pour rcuprer les
donnes au bon endroit

*/

int bitmap_check(yy_state_type state, char lu)                                   
{                                                                                
  int q, r;                                                                      
  char c;                                                                        
                                                                                 
  q = lu / 8; /* un char a 8 bits */                                          
  r = lu % 8;                                                                 
  c = yy_empty_state[state][q];                                                 

  if (c & (1 << (7 - r)))
   return 0;
  else
   return 1;
                                                       
}


yy_state_type yy_nxt(yy_state_type state, char lu)                              
{                                                                                
  if (bitmap_check(state, lu))                                                   
    return yy_next_with_lines[yy_skip[state]+lu];                  
  else                                                                           
    return - state;
}
"

let main_lignes () =
  let fich_out=Sys.argv.(2) and fich_in=Sys.argv.(1) in
    let in_channel = open_in fich_in and out_channel = open_out fich_out in
    let t= get_yy_nxt fich_in in
    let m = Array.length t and n = Array.length t.(0) in

      print_string ("FICHIER DE TRAVAIL : "^fich_in);
      print_newline();
      print_string "Au depart le tableau de transitions prend :\n";
      print_int (m * n);
      print_string " x sizeof(short)\n";
      print_string "soit avec sizeof(short) = 2 :\n";
      print_int (m * n * 2);
      print_string " octets.\n";

      let (trans,dec)=compresse_table t m n 
      and bad_states = make_bad_states t m n in 
	laissons_passer_jusque_yy_nxt in_channel out_channel;
	manger_jusque_semi_colomn in_channel;  

	ecrit_yy_nxt_with_lines trans (Array.length trans)  out_channel;
	ecrit_yy_skip dec m out_channel;                                   
	ecrit_yy_empty_state bad_states m  out_channel;                                     
	output_string out_channel gros_bout_de_c;                                          

	try
	  (
	    while true do
	      laissons_passer_jusque_yy_nxt in_channel out_channel;
	      let c1 = recuperer_truc_entre_crochets in_channel in
	      let c2 = recuperer_truc_entre_crochets in_channel in
		output_string out_channel ("yy_nxt(" ^ c1 ^ ", " ^ c2 ^ ")");
	    done
	  )
	with
	    End_of_file -> ();
	      
	      close_out out_channel;    
	      close_in in_channel;

	(*impression du resultat*)
	      print_newline();
	      print_string "VERSION 1 - TABLE COMPRESSION \n";
	      print_string "Les nouvelles tables prennent: \n";
	      print_int (Array.length trans);
	      print_string " x sizeof(short) pour les transitions.\n";
	      print_int (n / 8 * m);
	      print_string " x sizeof(char) pour les transitions nulles.\n";
	      print_int m;
	      print_string " x sizeof(short) pour savoir les dcalages.\n";
	      print_string "Soit un total avec sizeof(short) = 2 de :\n";
	      print_int ((Array.length trans + m) * 2 + (n / 8 * m));
	      print_string " octets.\n";;

main_lignes();













